package DX::Op::MemberOf;

use DX::ArrayStream;
use DX::RefSet;
use Moo;

with 'DX::Role::Op';

has member_var => (is => 'ro', required => 1);
has coll_var => (is => 'ro', required => 1);

sub run {
  my ($self, $state) = @_;
  ($state, my %args) = $self->_expand_args($state,
    member => $self->member_var,
    of => $self->coll_var
  );
  my ($member, $of) = @args{qw(member of)};
  die "member bound" if $member->is_bound;
  my $set = $state->facts->{my $type = $state->resolve_value($of)};
  my $ref_set = DX::RefSet->new(
    target => $type, names => [ $set->key_list ],
  );
  return $state->then($self->next)
               ->add_dependencies($member->id, $of->id)
               ->bind_root_set($member->id, $ref_set)
}

1;
